package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.numberrule;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.util.MesPcnException;
import cn.estsh.i3plus.mes.pcn.api.iservice.busi.INumberRulePackAttributeStrategyService;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.mes.model.GenSerialNoModel;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import org.springframework.stereotype.Component;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @Description : 出风口条码
 * @Reference :
 * @Author : puxiao
 * @CreateDate : 2025/6/30 18:57
 * @Modify:
 **/
@Component
public class AirOutletCustSnNumberRuleStrategyService implements INumberRulePackAttributeStrategyService {


    @Override
    public GenSerialNoModel execute(GenSerialNoModel genSerialNoModel) {
        if (null == genSerialNoModel) {
            MesPcnException.throwMesBusiException("请检查客户零件信息,零件[%s]客户零件关系未维护", genSerialNoModel.getPartNo());

        }
        Date date = new Date();
        genSerialNoModel.setYear(getYearShort(date));
        genSerialNoModel.setMonth(getMonthShort(date));
        genSerialNoModel.setDay(getDayShort(date));
        genSerialNoModel.setMinute(getDayOfYear(date));
        genSerialNoModel.setSecond(getBydMonthShort(date));
        return genSerialNoModel;
    }


    private String getYearShort(Date date) {
        return MesExtEnumUtil.YEAR_SHORT.valueOfDescription(Integer.parseInt(TimeTool.getYear(date)));
    }

    private String getBydMonthShort(Date date) {
        return MesExtEnumUtil.MONTH_SHORT.valueOfDescription(Integer.parseInt(TimeTool.getYear(date)));
    }

    private String getMonthShort(Date date) {
        String monthShort = "";
        int monthValue = Integer.parseInt(TimeTool.getMonth(date));
        switch (monthValue){
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
            case 8:
            case 9:
                monthShort =  String.valueOf(monthValue);
                break;
            case 10:
                monthShort = "0";
                break;
            case 11:
                monthShort = "A";
                break;
            case 12:
                monthShort = "B";
                break;
            default:
        }
        return monthShort;
    }

    private String getDayShort(Date date) {
        return TimeTool.pareDateToString("dd",date);
    }


    private String getDayOfYear(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        int dayOfYear = calendar.get(Calendar.DAY_OF_YEAR);
        DecimalFormat df = new DecimalFormat("000");
        return df.format(dayOfYear);
    }
}